package com.sun.jmx.snmp;

import com.sun.jmx.mbeanserver.Util;
import java.util.Vector;

public class SnmpOidDatabaseSupport implements SnmpOidDatabase
{
    private Vector<SnmpOidTable> tables;
    
    public SnmpOidDatabaseSupport() {
        this.tables = new Vector();
    }
    
    public SnmpOidDatabaseSupport(SnmpOidTable obj) {
        (this.tables = new Vector()).addElement(obj);
    }
    
    @Override
    public void add(SnmpOidTable snmpOidTable) {
        if (!this.tables.contains(snmpOidTable)) {
            this.tables.addElement(snmpOidTable);
        }
    }
    
    @Override
    public void remove(SnmpOidTable snmpOidTable) throws SnmpStatusException {
        if (!this.tables.contains(snmpOidTable)) {
            throw new SnmpStatusException("The specified SnmpOidTable does not exist in this SnmpOidDatabase");
        }
        this.tables.removeElement(snmpOidTable);
        return;
    }
    
    @Override
    public SnmpOidRecord resolveVarName(String s) throws SnmpStatusException {
        int i = 0;
        while (i < this.tables.size()) {
            try {
                return ((SnmpOidTable)this.tables.elementAt(i)).resolveVarName(s);
            }
            catch (SnmpStatusException ex) {
                if (i == this.tables.size() - 1) {
                    throw new SnmpStatusException(ex.getMessage());
                }
                ++i;
            }
        }
        return null;
    }
    
    @Override
    public SnmpOidRecord resolveVarOid(String s) throws SnmpStatusException {
        int i = 0;
        while (i < this.tables.size()) {
            try {
                return ((SnmpOidTable)this.tables.elementAt(i)).resolveVarOid(s);
            }
            catch (SnmpStatusException ex) {
                if (i == this.tables.size() - 1) {
                    throw new SnmpStatusException(ex.getMessage());
                }
                ++i;
            }
        }
        return null;
    }
    
    @Override
    public Vector<?> getAllEntries() {
        Vector<Object> vector = new Vector();
        for (int i = 0; i < this.tables.size(); ++i) {
            Vector<Object> vector2 = (Vector)Util.cast(((SnmpOidTable)this.tables.elementAt(i)).getAllEntries());
            if (vector2 != null) {
                for (int j = 0; j < vector2.size(); ++j) {
                    vector.addElement(vector2.elementAt(j));
                }
            }
        }
        return vector;
    }
    
    @Override
    public void removeAll() {
        this.tables.removeAllElements();
    }
}
